/************************************************************************
    Click Wheel Controler 0.01 like Apple iPod
        Programmed by Piroli YUKARINOMIYA (MagicVox)
        @see http://www.magicvox.net/archive/2010/04202045/
************************************************************************/

$.fn.clickwheel = function (option) {
    if (!option) option = {};
    return this.each(function () {
        var _this = jQuery(this);
        var x0 = _this.position().left;
        var y0 = _this.position().top;
        var sx = option.width  ? option.width  : _this.innerWidth();
        var sy = option.height ? option.height : _this.innerHeight();
        var rw = option.rw     ? option.rw     : parseInt(Math.max(sx, sy) * .5);
        var rc = option.rc     ? option.rc     : parseInt(Math.max(sx, sy) * .2);

        var _get_radius_theta = function (x, y) {
            var _x = x - x0 - sx * .5;
            var _y = y - y0 - sy * .5;
            return {
                r: Math.sqrt(_x * _x + _y * _y),
                t: Math.atan2(_y, _x) * 180 / Math.PI
            };
        };

        var _data;
        var _handler = function (e) {
            switch (e.type) {
            case 'mousedown':
                _data = {
                    dragging: 0,
                    prevX: e.pageX,
                    prevY: e.pageY
                };
                $.event.add (document, "mousemove mouseup", _handler);
                return false;
            case !_data.dragging && 'mousemove':
                if (e.pageX != _data.prevX || e.pageY != _data.prevY) {
                    _data.dragging = true;
                    if (option.scrollstart) option.scrollstart (e);
                }
            case 'mousemove':
                if (_data.dragging) {
                    var _p0 = _get_radius_theta (_data.prevX, _data.prevY);
                    var _p1 = _get_radius_theta (e.pageX, e.pageY);
                    var _dt = _p1.t - _p0.t;
                         if (_dt < -180) _dt += 360;
                    else if ( 180 < _dt) _dt -= 360;
                    if (option.scroll) option.scroll (e, _dt);
                    _data.prevX = e.pageX;
                    _data.prevY = e.pageY;
                }
                break;
            case 'mouseup':
                $.event.remove (document, "mousemove mouseup", _handler);
                if (_data.dragging) {
                    /*** Scroll ***/
                    if (option.scrollend) option.scrollend (e);
                }
                else {
                    /*** Click ***/
                    var _p = _get_radius_theta(e.pageX, e.pageY);
                    if (option.click)
                        if (_p.r <= rc)
                            option.click(e, 5) // Center
                        else if (_p.r <= rw && 60 <= _p.t && _p.t <= 120)
                            option.click(e, 2) // Down
                        else if (_p.r <= rw && (150 <= _p.t || _p.t <= -150))
                            option.click(e, 4) // Left
                        else if (_p.r <= rw && -120 <= _p.t && _p.t <= -60)
                            option.click(e, 8) // Up
                        else if (_p.r <= rw && -30 <= _p.t && _p.t <= 30)
                            option.click(e, 6) // Right
                        else if (_p.r <= rw)
                            option.click(e, 0); // No Actions
                        else
                            option.click(e, -1); // Margin
                }
                break;
            }
            return true;
        };
        $.event.add (this, 'mousedown', _handler);
        if (this.attachEvent)
            this.attachEvent ('ondragstart', function () { return false; });
    });
};